
package de.ivu.elect.presentation.ergebnis;

import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;

import de.ivu.elect.business.ergebnis.boundary.ErgebnisConversationStore;
import de.ivu.elect.business.ergebnis.boundary.ErgebnisExtendedDAO;
import de.ivu.elect.business.ergebnis.boundary.ErgebnisEdit;
import de.ivu.elect.business.ergebnis.entity.Ergebnis;
import de.ivu.elect.business.ergebnis.entity.ErgebnisMeta;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.security.UseCaseSecure;
import de.ivu.elect.presentation.View;
import de.ivu.elect.jee.presentation.redirect.Redirect;

@Named(AbstractErgebnisEditNoScopeView.COMPONENT_NAME)
@View(viewId = AbstractErgebnisEditNoScopeView.VIEW_ID, useCase = UseCasePermission.ERGEBNIS_EDIT)
public abstract class AbstractErgebnisEditNoScopeView extends de.ivu.elect.presentation.AbstractElectEditView<Ergebnis>  {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "ergebnisEditView";

  public static final String VIEW_ID = "/ergebnis/ergebnis-edit.xhtml";

  public static final String PARENT_VIEW_ID = "/ergebnis/ergebnis-search.xhtml";

  @Inject
  protected transient ErgebnisExtendedDAO extendedDAO;

  @Inject
  protected transient ErgebnisEdit edit;

  @Inject
  @ConversationGroup(ErgebnisConversationStore.class)
  protected transient ErgebnisConversationStore conversationStore;

  @Inject
  protected transient ErgebnisMeta entityMeta;

  @Inject
  // ELECTDD-204 Auf doppelte Bearbeitung von Entitäten Hinweisen
  protected transient ErgebnisEditViewScopeStore entityViewStore;

  @de.ivu.elect.jee.faces.PreConditionCheck
  public String checkPreCondition() {
    if (getEntity() == null) {
      return getParentViewId();
    }
    return null;
  }

  @Override
  public Ergebnis getEntity() {
    if (conversationStore.getEntityPK() != null) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }
    return null;
  }

  public void setEntity(Ergebnis entity) {
    resetModel(); // DynaForm-Model zurücksetzen, damit die aktuelle Entität verwendte wird...
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  public boolean isEntitySet() {
    return conversationStore.getEntityPK() != null;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.ERGEBNIS_DELETE)
  @Override
  public String delete() {
    return delete(getEntity());
  }

  protected String delete(Ergebnis entity) {
    edit.delete(entity);

    addMessageDeleteSuccess();

    resetStateAfterAction();
    return getParentViewId(); // definierter Parent, benutze deleteAndGoBack um zum vorherigen View zurückzukehren
  }



  @Redirect
  @UseCaseSecure(UseCasePermission.ERGEBNIS_DELETE)
  public String deleteAndGoBack() {
    delete();
    return goBack(getParentViewId());
  }

  protected void addMessageDeleteSuccess() {
    addInfoMessage("entity.edit.action.delete.success.message", entityMeta.getEinzahlMessage());
  }

  public boolean isBtnDeleteRendered() {
    return hasPermission(UseCasePermission.ERGEBNIS_DELETE);
  }

  @Redirect
  @Override
  public String cancel() {
    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  @Override
  public boolean isBtnCancelRendered() {
    return true;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.ERGEBNIS_EDIT)
  @Override
  public String save() {
    Ergebnis entity = getEntity();

    callSave(entity);

    addMessageSaveSuccess(entity);

    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  protected void callSave(Ergebnis entity) {
    edit.save(entity);
  }

  @Redirect
  @Override
  public String reset() {
    super.reset();
    Ergebnis entity = getEntity();
    resetStateAfterAction();
    setEntity(entity);
    return getViewId();
  }

  protected void addMessageSaveSuccess(Ergebnis entity) {
    addInfoMessage("entity.edit.action.save.success.message", entityMeta.getEinzahlMessage());
  }

  @Override
  protected boolean isSavePermissionVorhanden() {
    return hasPermission(UseCasePermission.ERGEBNIS_EDIT);
  }
  
  @Redirect
  public String edit(Ergebnis entity) {
    conversationStore.setEntityPK(entity.getPk());
    return getViewId();
  }

  protected String getViewId() {
    return VIEW_ID;
  }

  protected String getParentViewId() {
    return PARENT_VIEW_ID;
  }

  protected void resetStateAfterAction() {
    conversationStore.close();
  }

  @de.ivu.elect.jee.faces.PreConditionCheck
  public void checkDoppelteBearbeitung() {
     entityViewStore.setEntity(getEntity());
  }

  @org.apache.deltaspike.core.api.scope.ViewAccessScoped
  public static class ErgebnisEditViewScopeStore extends  de.ivu.elect.presentation.edit.AbstractViewScopeStore<Ergebnis,   de.ivu.elect.business.ergebnis.entity.ErgebnisPK  > {

    private static final long serialVersionUID = 1L;
  }
}
